=== debian/changelog ===
ns3 (3.13-1) unstable; urgency=low

  * New upstream release.
  * Linked with --as-needed option.

 -- YunQiang Su <wzssyqa@gmail.com>  Sat, 24 Dec 2011 18:15:24 +0800

ns3 (3.12.1+dfsg1-5) unstable; urgency=low

  * doesn't depend on procps, read /proc/meminfo directly.
  * build for python2.7 as defaut python.
  * build depend on only default python instead of python-all.
  * bump compat to 9 to use dpkg-buildflags to export
    CFLAGS etc by default like before.

 -- YunQiang Su <wzssyqa@gmail.com>  Sun, 02 Oct 2011 04:52:16 +0000

ns3 (3.12.1+dfsg1-4) unstable; urgency=low

  [debian/rules]:
    fix the call of awk: $ -> $$
  [debian/control]:
  	add build depends of procps to get the memory.

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 22 Sep 2011 14:13:34 +0800
